#!/usr/bin/env python
# coding: utf-8

# # class 2 hw

# In[7]:


def bmi_func(weight,height):
    '''
    输入
    - weight : 体重（kg）
    - height : 身高 (m)
    输出
    BMI值表示人的...
    '''
    bmi = weight/height**2
    return bmi


# In[8]:


bmi_func(70,1.75)


# In[9]:


help(bmi_func)


# $$2^6+\frac{4}{5}- \sum_{k=1}^{15} \sqrt{k}$$

# In[10]:


s = 0
for k in range(1,16):
    s = s+ k**0.5
s


# In[11]:


2**6+4/5+s


# # Python 基础

# ## 复合数据结构

# ### 字符串 string

# 表示文本，通过英文的单引号或者英文的双引号生成，有顺序，且元素不能更改。

# In[12]:


a = 'hello world'


# In[13]:


type(a)


# In[14]:


b = "hello world"


# In[15]:


a == b


# In[16]:


print(a)


# Python 从0开始计数，意味着 第一个元素 它的位置（索引）用0表示，第二个位置用1表示

# In[18]:


a[2] # 提取a中第3个元素（索引为2）


# In[19]:


a[10]


# In[20]:


len(a)


# In[21]:


a[len(a)-1]


# In[22]:


a[-1]


# In[24]:


# 拼接
a +  '!!!!!!'


# In[25]:


s = ''
for i in range(10):
    s = s + '*'
    print(s)


# In[27]:


a*3


# ### 列表 list

# 通过英文的方括号[]生成，元素有顺序，可以更改

# In[28]:


b = ['peter',175,60,'male',True]


# In[30]:


b[3][2]


# In[31]:


b + [2,5,7]


# In[33]:


b.append(2000)


# In[34]:


b


# In[37]:


b0 = []
for k in range(1,21):
    b0.append(k**0.5)
    print(b0)
b0


# In[39]:


sum(b0)


# In[40]:


a1 = 'python is the greatest programming language!'


# In[41]:


a1.split(' ')


# In[43]:


b1 = a1.split(' ')


# In[44]:


b1


# In[45]:


'+++'.join(b1)


# In[48]:


b1[1] = 'IS'


# In[49]:


b1


# In[ ]:





# ### 元组 tuple

# 由英文的圆括号()生成，元素有顺序，不可更改

# In[50]:


c = (100,40,'水泥','SHANGHAI')


# In[51]:


type(c)


# In[52]:


c[2]


# In[54]:


#c[2] = '塑料'


# In[ ]:





# In[ ]:





# ### 字典 dict

# 通过英文的花括号{}生成，每个元素中间由英文的冒号: 分割，前面的部分称为键key，后面的称为值 value

# In[55]:


d = {'A':50,'B':60,'C':70,'D':80}


# In[57]:


d['C']


# In[58]:


d1 = {'a':[1,2,3,4,5],'b':789,'c':True}


# In[59]:


d1['c']


# In[60]:


d1['s'] = 895


# In[61]:


d1


# In[62]:


d1.keys()


# In[63]:


d1.values()


# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# ### 集合 set

# 通过英文的花括号生成，集合元素中间没有冒号，元素没有顺序

# In[64]:


s = {1,2,3,3,5,7,8,8}


# In[67]:


s


# In[68]:


3 in s


# In[69]:


s


# In[70]:


s1 = {3,4,5}


# In[71]:


s & s1


# In[72]:


s|s1


# # 循环判断语句

# ## 判断语句

# In[77]:


n = float(input('please input a number:'))


# In[79]:


n = -30
if n > 0:
    print('positive')


# In[80]:


n = -30
if n > 0:
    print('positive')
else:
    print('not positive')


# In[81]:


n = -30
if n > 0:
    print('positive')
elif n == 0:
    print('zero')
else:
    print('not positive')


# ## For循环

# In[82]:


a = 'hello world'
for i in range(len(a)):
    print(a[i])


# In[83]:


b = [2,3,4,5,True]
for i in b:
    print(i)


# In[84]:


c = [2**1,2**2,2**3,2**4,2*5]


# In[85]:


c


# In[86]:


c0 = []
for i in range(1,6):
    c0.append(2**i)
c0


# In[87]:


[2**i for i in range(1,6)]


# In[88]:


[2**i for i in range(1,6,2)]


# In[89]:


[2**i for i in range(1,10) if i%3==0]


# ## while

# In[ ]:





# # Python数据分析

# ## 绘图 matplotlib

# In[90]:


import matplotlib.pyplot as plt


# $$y=2x^2+3x+4$$

# In[91]:


def func_guo(x):
    return 2*x**2+3*x+4


# In[92]:


x = range(-10,11)
y = [func_guo(i) for i in x]


# In[97]:


plt.plot(x,y,color='green')
plt.title('quadratic function')
plt.xlabel('x')
plt.ylabel('y')
plt.show()


# In[98]:


import matplotlib.pyplot as plt
import numpy as np

from matplotlib import cm
from matplotlib.ticker import LinearLocator

fig, ax = plt.subplots(subplot_kw={"projection": "3d"})

# Make data.
X = np.arange(-5, 5, 0.25)
Y = np.arange(-5, 5, 0.25)
X, Y = np.meshgrid(X, Y)
R = np.sqrt(X**2 + Y**2)
Z = np.sin(R)

# Plot the surface.
surf = ax.plot_surface(X, Y, Z, cmap=cm.coolwarm,
                       linewidth=0, antialiased=False)

# Customize the z axis.
ax.set_zlim(-1.01, 1.01)
ax.zaxis.set_major_locator(LinearLocator(10))
# A StrMethodFormatter is used automatically
ax.zaxis.set_major_formatter('{x:.02f}')

# Add a color bar which maps values to colors.
fig.colorbar(surf, shrink=0.5, aspect=5)

plt.show()


# In[99]:


data = [1,2,3,4,5,4,6,7,5,6,7,8,9,12]


# In[100]:


plt.hist(data)


# In[ ]:




